;
; Test_DF12P.asm ---  Test program for Dragonfly12-Plus module, (c)2009, EVBplus.com
;     Author: Wayne Chu
;     Date: 08/03/09
;
;     Function:
;     The Dragonfly12-Plus module is pre-installed with serial monitor and 
;     a simple test program at factory. The state of the slide switch (S2)
;     is tested by the serial monitor for selecting RUN or LOAD mode during 
;     power up or reset, and the PE4 LED will blinktwice to indicate that 
;     the serial monitor is functioning.  
;     If the slide switch is placed in "LOAD" mode the monitor will wait for
;     a command from PC. 
;     If the slide switch is placed in "RUN" mode the LED will blinktwo more 
;     times to indicate that the program execution is diverted to the user code.
;     
;     When the user code (the pre-loaded factory test program) is loaded
;     the LED indicator will flash rapidly.
;
;     If the serial monitor is not installed or erased by a BDM, the LED indicator
;     will not blink during power up or reset.

;   
;   
#include           reg9s12.h      ; include register equates

STACK   equ        $3fce

REGBLK: equ        $0000
DB3:    equ        8
DB4:    equ        $10



;D_200us:        equ        1200       ; 200us at 48MHz crystal
;D_200us:        equ        400        ; 200us at 16MHz crystal
D_200us:        equ        200        ; 200us at 8MHz crystal
;D_200us:        equ        100        ; 200us at 4MHz crystal






        org        $E000
;
start:
        lds        #STACK
        ldx        #REGBLK

        ldaa       #DB4
        staa       ddre,x          ; make PE4 a LED output
	jsr	   delay
        jsr	   delay
	jsr	   delay
	jsr	   delay
	jsr	   delay
        jsr	   delay

back:   bset       porte, DB4	   ; turn on PE4 LED
	jsr	   delay
        jsr	   delay
	
	jsr	   delay
	bclr       porte, DB4	   ; turn off PE4 LED
	jsr	   delay
	jsr	   delay
	jsr	   delay
	jsr	   delay
        jmp        back




delay   ldab       #150            ; 150 x 200us = 30ms
dly1:   ldy        #D_200us        ; 1200 x 4 = 4800 cycles, 200us at 48 MHz crystal
dly2:   dey                        ; 1 cycle
        bne        dly2            ; 3 cycles
        decb
        bne        dly1
        rts        

BadInt: rti                      ; handle UNexpected interrupts...
; ----------------- VECTOR TABLE --------------------
        org        $FF8A    ;Original vector table for CW download
;
        fdb        BadInt        ;$FF8A: VREG LVI
        fdb        BadInt        ;$FF8C: PWM emergency shutdown
        fdb        BadInt        ;$FF8E: PortP
        fdb        BadInt        ;$FF90: Reserved
        fdb        BadInt        ;$FF92: Reserved
        fdb        BadInt        ;$FF94: Reserved
        fdb        BadInt        ;$FF96: Reserved
        fdb        BadInt        ;$FF98: Reserved
        fdb        BadInt        ;$FF9A: Reserved
        fdb        BadInt        ;$FF9C: Reserved
        fdb        BadInt        ;$FF9E: Reserved
        fdb        BadInt        ;$FFA0: Reserved
        fdb        BadInt        ;$FFA2: Reserved
        fdb        BadInt        ;$FFA4: Reserved
        fdb        BadInt        ;$FFA6: Reserved
        fdb        BadInt        ;$FFA8: Reserved
        fdb        BadInt        ;$FFAA: Reserved
        fdb        BadInt        ;$FFAC: Reserved
        fdb        BadInt        ;$FFAE: Reserved
        fdb        BadInt        ;$FFB0: CAN transmit
        fdb        BadInt        ;$FFB2: CAN receive
        fdb        BadInt        ;$FFB4: CAN errors
        fdb        BadInt        ;$FFB6: CAN wake-up
        fdb        BadInt        ;$FFB8: FLASH
        fdb        BadInt        ;$FFBA: Reserved
        fdb        BadInt        ;$FFBC: Reserved
        fdb        BadInt        ;$FFBE: Reserved
        fdb        BadInt        ;$FFC0: Reserved
        fdb        BadInt        ;$FFC2: Reserved
        fdb        BadInt        ;$FFC4: CRG self-clock-mode
        fdb        BadInt        ;$FFC6: CRG PLL Lock
        fdb        BadInt        ;$FFC8: Reserved
        fdb        BadInt        ;$FFCA: Reserved
        fdb        BadInt        ;$FFCC: Reserved
        fdb        BadInt        ;$FFCE: PORTJ
        fdb        BadInt        ;$FFD0: Reserved
        fdb        BadInt        ;$FFD2: ATD
        fdb        BadInt        ;$FFD4: Reserved
        fdb        BadInt        ;$FFD6: SCI Serial System
        fdb        BadInt        ;$FFD8: SPI Serial Transfer Complete
        fdb        BadInt        ;$FFDA: Pulse Accumulator Input Edge
        fdb        BadInt        ;$FFDC: Pulse Accumulator Overflow
        fdb        BadInt        ;$FFDE: Timer Overflow
        fdb        BadInt        ;$FFE0: Standard Timer Channel 7
        fdb        BadInt        ;$FFE2: Standard Timer Channel 6
        fdb        BadInt        ;$FFE4: Standard Timer Channel 5;
        fdb        BadInt        ;$FFE6: Standard Timer Channel 4
        fdb        BadInt        ;$FFE8: Standard Timer Channel 3
        fdb        BadInt        ;$FFEA: Standard Timer Channel 2
        fdb        BadInt        ;$FFEC: Standard Timer Channel 1
        fdb        BadInt        ;$FFEE: Standard Timer Channel 0
        fdb        BadInt        ;$FFF0: Real Time Interrupt (RTI)
        fdb        BadInt        ;$FFF2: IRQ (External Pin or Parallel I/O) (IRQ)
        fdb        BadInt        ;$FFF4: XIRQ (Pseudo Non-Maskable Interrupt) (XIRQ)
        fdb        BadInt        ;$FFF6: Software Interrupt (SWI)
        fdb        BadInt        ;$FFF8: Illegal Opcode Trap ()
        fdb        start         ;$FFFA: COP Failure (Reset) ()
        fdb        BadInt        ;$FFFC: Clock Monitor Fail (Reset) ()
        fdb        start         ;$FFFE: /RESET
        end


       